diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonSwarming.ml ./src/daemon/common/commonSwarming.ml
--- ./src/daemon/common/commonSwarming.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/daemon/common/commonSwarming.ml	2006-05-25 20:48:14.000000000 +0200
@@ -831,264 +932,350 @@
 
   lprintf_nl "Files:";
   List.iter (fun t ->
-      lprintf_nl "  File num: %d" (file_num t.t_file);
-      lprintf_nl "  %s" (if t.t_primary then "primary" else "secondary");
-      lprintf_nl "  Downloaded: %Ld" (file_downloaded t.t_file);
-      lprintf_nl "  Bitmap: %s" t.t_converted_verified_bitmap
+    lprintf_nl "  File num: %d" (file_num t.t_file);
+    lprintf_nl "  %s" (if t.t_primary then "primary" else "secondary");
+    lprintf_nl "  Downloaded: %Ld" (file_downloaded t.t_file);
+    lprintf_nl "  Bitmap: %s" t.t_converted_verified_bitmap
   ) s.s_networks
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         iter_block_ranges                             *)
-(*                                                                       *)
-(*************************************************************************)
+(** iter function f over all the ranges of a block *)
 
 let iter_block_ranges f b =
   let rec iter_range f r =
+    let next = r.range_next in (* keep next range in case f mutates it *)
     f r;
-    match r.range_next with
-      None -> ()
+    match next with
+    | None -> ()
     | Some rr -> iter_range f rr
   in
   iter_range f b.block_ranges
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         print_block                                   *)
-(*                                                                       *)
-(*************************************************************************)
+(** (debug) output a [block] to current log *)
 
 let print_block b =
   lprintf_n "Block %d: %Ld-%Ld"
     b.block_num b.block_begin b.block_end;
   lprint_newline ();
   lprintf_nl "  ranges:";
-  let rec iter_range r =
-    lprintf_nl "   %Ld-%Ld" r.range_current_begin r.range_end;
-    match r.range_next with
-      None -> ()
-    | Some rr -> iter_range rr
-  in
-  iter_range b.block_ranges;
+  iter_block_ranges (fun r ->
+    lprintf_nl "   %Ld-%Ld" r.range_begin r.range_end) b;
   lprint_newline ()
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         add_file_downloaded                           *)
-(*                                                                       *)
-(*************************************************************************)
+(** (shadows CommonFile.add_file_downloaded) 
+    increments amount downloaded of the primary frontend of the swarmer,
+    and of maybe_t, if provided, and if it's different from the primary. *)
 
 let add_file_downloaded maybe_t s size =
 (*  lprintf "add_file_downloaded %Ld\n" size; *)
   match s.s_networks with
-    t :: _ when t.t_primary ->
+  | t :: _ ->
+      assert(t.t_primary);
       add_file_downloaded t.t_file size;
-      begin
-        match maybe_t with
-          None -> ()
-        | Some tt when t != tt ->
-            add_file_downloaded tt.t_file size;
-        | _ -> ()
-      end;
+      (match maybe_t with
+       | None -> ()
+       | Some tt ->
+	   if t != tt then
+             add_file_downloaded tt.t_file size);
       if file_downloaded t.t_file < zero then
-          lprintf_nl "ERROR: file_downloaded < zero!";
-
-  | _ -> ()
+        lprintf_nl "ERROR: file_downloaded < zero!";
+      
+  | _ -> assert false
+
+(** Close all the ranges of a block, adding their size to the
+    downloaded amount *)
+
+let close_block_ranges maybe_t s b =
+  iter_block_ranges (fun r ->
+    let added = r.range_end -- r.range_begin in
+    add_file_downloaded maybe_t s added;
+    b.block_remaining <- b.block_remaining -- added;
+    r.range_begin <- r.range_end;
+    r.range_prev <- None;
+    r.range_next <- None) b;
+  if b.block_remaining <> 0L then
+    lprintf_nl "WARNING: block_remaining should be 0 after close_block_ranges"
 
 (*************************************************************************)
 (*                                                                       *)
-(*                         close_ranges (internal)                       *)
+(*                         swarmers verified bitmaps                     *)
 (*                                                                       *)
 (*************************************************************************)
 
-let rec close_ranges maybe_t s r =
+(* For every swarmer, there is a "primary" verifier, and secondary
+   verifiers.  When a block is downloaded, it is tagged '2' in the
+   verified_bitmap, and this '2' is propagated to the primary bitmap if
+   possible (if all sub-blocks are also '2'). If the primary chunk
+   becomes '2', then a verification is needed on the primary. If the
+   verification works, the verified_bitmap becomes '3', and the secondary
+   verifiers are tagged with '2' (if they use a different verification
+   scheme) or '3' (if no verification scheme or a verification scheme
+   that has already been used). *)
 
-  let added = r.range_end -- r.range_current_begin in
-  add_file_downloaded maybe_t s added;
-  let b = r.range_block in
-  b.block_remaining <- b.block_remaining -- added;
-
-  r.range_current_begin <- r.range_end;
-  match r.range_next with
-    None -> ()
-  | Some rr ->
-      r.range_prev <- None;
-      r.range_next <- None;
-      close_ranges maybe_t s rr
-
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_downloaded_block                          *)
-(*                                                                       *)
-(*************************************************************************)
-
-let set_downloaded_block maybe_t s i =
-  match s.s_blocks.(i) with
-    EmptyBlock ->
-      let block_begin = compute_block_begin s i in
-      let block_end = compute_block_end s i in
-      add_file_downloaded maybe_t s (block_end -- block_begin)
-  | PartialBlock b ->
-      let rec iter r =
-        add_file_downloaded maybe_t s (r.range_end -- r.range_current_begin);
-        r.range_current_begin <- r.range_end;
-        match r.range_next with
-          None -> r.range_prev <- None; r
-        | Some rr ->
-            r.range_prev <- None;
-            r.range_next <- None;
-            iter rr
-      in
-      b.block_ranges <- iter b.block_ranges
-  | _ -> ()
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_verified_bitmap (internal)                *)
-(*                                                                       *)
-(*************************************************************************)
-
-(* For every swarmer, there is a "primary" verifier, and secondary verifiers.
-When a block is downloaded, it is tagged '2' in the verified_bitmap, and
-this '2' is propagated to the primary bitmap if possible (if all sub-blocks
-are also '2'). If the primary chunk becomes '2', then a verification is
-needed on the primary. If the verification works, the verified_bitmap
-becomes '3', and the secondary verifiers are tagged with '2' (if they use
-a different verification scheme) or '3' (if no verification scheme or
-a verification scheme that has already been used). *)
-
-(* corruption has been detected, and the block has been reset to 0 *)
-let set_bitmap_0 s i =
-  if s.s_verified_bitmap.[i] > '1' then begin
-      s.s_verified_bitmap.[i] <- '0';
-      List.iter (fun t ->
-          let j = t.t_chunk_of_block.(i) in
-          if List.for_all (fun i -> s.s_verified_bitmap.[i] = '0')
-            t.t_blocks_of_chunk.(j) then
-            t.t_converted_verified_bitmap.[j] <- '0'
-      ) s.s_networks
-    end
+(* corruption has been detected, and the block has been reset to 0 *)
+let set_swarmer_bitmap_0 s i =
+  (* shouldn't it be > '0' ? *)
+  if s.s_verified_bitmap.[i] > '1' then begin
+      s.s_verified_bitmap.[i] <- '0';
+      List.iter (fun t ->
+          let j = t.t_chunk_of_block.(i) in
+	  match t.t_converted_verified_bitmap.[j] with
+	  | '0' -> ()
+	  | '1' ->
+	      if List.for_all (fun i -> s.s_verified_bitmap.[i] = '0')
+		t.t_blocks_of_chunk.(j) then
+		  t.t_converted_verified_bitmap.[j] <- '0'
+	  | '2' -> lprintf_nl "set_swarmer_bitmap_0: invalidating a block within a completed chunk?"
+	  | '3' -> lprintf_nl "set_swarmer_bitmap_0: invalidating a block within a verified chunk?"
+	  | _ -> assert false
+      ) s.s_networks
+    end
 
 (* we have started downloading this block, so mark all containing blocks
   also as started. *)
-let set_bitmap_1 s i =
-  if s.s_verified_bitmap.[i] = '0' then begin
+let set_swarmer_bitmap_1 s i =
+  match s.s_verified_bitmap.[i] with
+  | '0' ->
       s.s_verified_bitmap.[i] <- '1';
       List.iter (fun t ->
-          let j = t.t_chunk_of_block.(i) in
-          if t.t_converted_verified_bitmap.[j] = '0' then
-            t.t_converted_verified_bitmap.[j] <- '1'
+        let j = t.t_chunk_of_block.(i) in
+        match t.t_converted_verified_bitmap.[j] with
+	| '0' -> t.t_converted_verified_bitmap.[j] <- '1'
+	| '1' -> ()
+	| '2' -> lprintf_nl "set_bitmap1: partial block within a completed chunk?"
+	| '3' -> lprintf_nl "set_bitmap1: partial block within a verified chunk?"
+	| _ -> assert false
       ) s.s_networks
-    end
-
-(* we finished this block, we need know to verify it *)
-let set_bitmap_2 s i =
-  if s.s_verified_bitmap.[i] < '2' then begin
-      s.s_verified_bitmap.[i] <- '2';
+  | '1' -> ()
+  | '2' -> lprintf_nl "set_swarmer_bitmap_1: trying to demote a completed block?"
+  | '3' -> lprintf_nl "set_swarmer_bitmap_1: trying to demote a verified block?"
+  | _ -> assert false
+	
+
+(* we finished this block, trying to escalate to primary frontend
+   verification bitmap *)
+let set_swarmer_bitmap_2 s i =
+  match s.s_verified_bitmap.[i] with
+  | '0' | '1' ->
+      (s.s_verified_bitmap.[i] <- '2';
       match s.s_networks with
-      | t :: _ when t.t_primary ->
+      | t :: _ ->
+	  assert (t.t_primary);
           let j = t.t_chunk_of_block.(i) in
-          if List.for_all (fun i -> s.s_verified_bitmap.[i] = '2')
-            t.t_blocks_of_chunk.(j) &&
-            t.t_converted_verified_bitmap.[j] <> '3' then begin
-              t.t_ncomplete_blocks <- t.t_ncomplete_blocks + 1;
-              t.t_converted_verified_bitmap.[j] <- '2'
-            end
-      | [] -> assert false
-      | _ -> ()
-    end
+	  (match t.t_converted_verified_bitmap.[j] with
+	  | '0' | '1' -> 
+	      if List.for_all (fun i -> s.s_verified_bitmap.[i] = '2')
+		t.t_blocks_of_chunk.(j) then begin
+		  t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1;
+		  t.t_converted_verified_bitmap.[j] <- '2'
+		end
+	  | '2' -> ()
+	  | '3' -> 
+	      (* lprintf_nl "set_swarmer_bitmap_2: trying to demote a verified block? (1)" *)
+	      ()
+	  | _ -> assert false)
+      | [] -> assert false)
+  | '2' -> ()
+  | '3' -> lprintf_nl "set_swarmer_bitmap_2: trying to demote a verified block? (2)"
+  | _ -> assert false
 
 (* the primary verifier has worked, so let ask secondary ones for
-verification too *)
-let set_bitmap_3 s i =
-  if s.s_verified_bitmap.[i] < '3' then begin
-      s.s_verified_bitmap.[i] <- '3';
-(*      lprintf "set_bitmap_3 %d done\n" i; *)
+   verification too *)
+let set_swarmer_bitmap_3 s i =
+  match s.s_verified_bitmap.[i] with
+  | '0' | '1' | '2' ->
+      (s.s_verified_bitmap.[i] <- '3';
+(*      lprintf "set_swarmer_bitmap_3 %d done\n" i; *)
       match s.s_networks with
-        [] -> assert false
-      | tprim :: tail ->
-          List.iter (fun t ->
-              let j = t.t_chunk_of_block.(i) in
-              if List.for_all (fun i -> s.s_verified_bitmap.[i] = '3')
-                t.t_blocks_of_chunk.(j) then
-                match t.t_verifier with
-                  NoVerification ->
-                    t.t_converted_verified_bitmap.[j] <- '3'
-                | _ ->
-                    t.t_ncomplete_blocks <- t.t_ncomplete_blocks + 1;
-                    t.t_converted_verified_bitmap.[j] <- '2'
-          ) tail
-    end
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_toverify_block (internal)                 *)
-(*                                                                       *)
-(*************************************************************************)
-
-    (*
-let set_toverify_block s i = set_bitmap_2 s i
-    *)
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_completed_block (internal)                *)
-(*                                                                       *)
-(*************************************************************************)
+      | [] -> assert false
+      | tprim :: secondaries ->
+	  assert (tprim.t_primary);
+	  (* that test is somewhat redundant, since only primary
+	     frontends with verification can have merged secondary
+	     frontends; See merge *)
+	  match tprim.t_verifier with
+	  | NoVerification | VerificationNotAvailable -> ()
+	  | Verification _ | ForceVerification ->
+	      let jprim = tprim.t_chunk_of_block.(i) in
+	      assert (tprim.t_converted_verified_bitmap.[jprim] = '3');
+	      List.iter (fun t ->
+		assert (not t.t_primary);
+		let j = t.t_chunk_of_block.(i) in
+		if List.for_all (fun i -> s.s_verified_bitmap.[i] = '3')
+                  t.t_blocks_of_chunk.(j) then
+		    match t.t_verifier with
+		    | NoVerification | VerificationNotAvailable ->
+			(* we have no way to check data integrity
+			   for this network, assume other(s) know
+			   better *)
+			(match t.t_converted_verified_bitmap.[j] with
+			 | '0' | '1' ->
+			     t.t_converted_verified_bitmap.[j] <- '3';
+			     t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1;
+			     t.t_nverified_chunks <- t.t_nverified_chunks + 1
+			 | '2' ->
+			     t.t_converted_verified_bitmap.[j] <- '3';
+			     t.t_nverified_chunks <- t.t_nverified_chunks + 1
+			 | '3' -> ()
+			 | _ -> assert false)
+		    | ForceVerification
+		    | Verification _ ->
+			(* all chunks are verified, so set
+			   converted_verified_bitmap to '2',
+			   probably to trigger data verification later.
+			   
+			   Is that code necessary at all ? *)
+			(match t.t_converted_verified_bitmap.[j] with
+			 | '0' | '1' ->
+			     t.t_converted_verified_bitmap.[j] <- '2';
+			     t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1
+			 | '2' -> ()
+			 | '3' -> lprintf_nl "set_swarmer_bitmap_3: trying to demote a verified block in another frontend?"
+			 | _ -> assert false)
+	      ) secondaries)
+  | '3' -> ()
+  | _ -> assert false
+
+(** set block as completed, closing all remaining ranges, and
+    incrementing amount downloaded by their total size.
+    If the block was empty its whole size is added *)
 
 let set_completed_block maybe_t s i =
-  begin
-    match s.s_blocks.(i) with
-      PartialBlock b -> close_ranges maybe_t s b.block_ranges
-    | _ -> ()
-  end;
+  let mark_completed () =
+    set_swarmer_bitmap_2 s i;
+    s.s_blocks.(i) <- CompleteBlock in
   match s.s_blocks.(i) with
-    CompleteBlock | VerifiedBlock -> ()
-  | _ ->
-      set_downloaded_block maybe_t s i;
-      set_bitmap_2 s i;
-      s.s_blocks.(i) <- CompleteBlock
+  | CompleteBlock | VerifiedBlock -> ()
+  | EmptyBlock ->
+      let block_begin = compute_block_begin s i in
+      let block_end = compute_block_end s i in
+      add_file_downloaded maybe_t s (block_end -- block_begin);
+      mark_completed ()
+  | PartialBlock b ->
+      close_block_ranges maybe_t s b;
+      mark_completed ()
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_verified_block (internal)                 *)
-(*                                                                       *)
-(*************************************************************************)
+(** set block as verified, closing all remaining ranges, and
+    incrementing amount downloaded by their total size.
+    If the block was empty its whole size is added 
+
+    (is it normal that no maybe_t can be provided ? my guess is that
+    this function is always called on behalf of a primary frontend) *)
 
 let set_verified_block s j =
   match s.s_blocks.(j) with
-    VerifiedBlock -> ()
+  | VerifiedBlock -> ()
   | _ ->
       set_completed_block None s j;
       s.s_blocks.(j) <- VerifiedBlock;
-      set_bitmap_3 s j
+      set_swarmer_bitmap_3 s j
 
 (*************************************************************************)
 (*                                                                       *)
-(*                         set_verified_chunk (internal)                 *)
+(*                        frontends verified bitmaps                     *)
 (*                                                                       *)
 (*************************************************************************)
 
-let set_verified_chunk t i =
-  t.t_nverified_blocks <- t.t_nverified_blocks + 1;
-  t.t_converted_verified_bitmap.[i] <- '3';
+(* We've seen how swarmer verification propagates to the frontend(s)
+   verifications, now let's see the reverse *)
+	
+let set_frontend_bitmap_0 t j =
+  assert(t.t_converted_verified_bitmap.[j] = '2');
   let s = t.t_s in
-  if t.t_primary then begin
-    (* The primary is supposed to propagate verified chunks to the file *)
-      List.iter (fun j -> set_verified_block s j) t.t_blocks_of_chunk.(i);
-      if !verbose_swarming then
-        print_s "VERIFIED" s
+  assert(List.for_all (fun i -> s.s_verified_bitmap.[i] <> '3') t.t_blocks_of_chunk.(j));
+  t.t_ncomplete_chunks <- t.t_ncomplete_chunks - 1;
+  if List.for_all (fun i -> s.s_verified_bitmap.[i] = '2') t.t_blocks_of_chunk.(j) then begin
+      if !verbose_swarming || !verbose then
+        lprintf_nl "Complete block %d/%d of %s failed verification, reloading..."
+          (j + 1) t.t_nchunks (file_best_name t.t_file);
+      
+      t.t_converted_verified_bitmap.[j] <- '0';
+      List.iter (fun i ->
+        match s.s_blocks.(i) with
+	| EmptyBlock -> set_swarmer_bitmap_0 s i
+        | PartialBlock _ ->  set_swarmer_bitmap_1 s i
+        | CompleteBlock ->
+            let block_begin = compute_block_begin s i in
+            let block_end = compute_block_end s i in
+	    (* negative *)
+            add_file_downloaded None s (block_begin -- block_end);
+	      
+            s.s_blocks.(i) <- EmptyBlock;
+            set_swarmer_bitmap_0 s i
+	      
+        | VerifiedBlock -> assert false
+      ) t.t_blocks_of_chunk.(j)
     end
+  else begin
+    (* afaiu not supposed to happen, so this code is for debugging ? *)
+    if !verbose_swarming then begin
+      let nsub = ref 0 in
+      lprintf_n "  Swarmer was incomplete: ";
+      List.iter (fun i ->
+        lprintf "%c" s.s_verified_bitmap.[i];
+        if s.s_verified_bitmap.[i] = '2' then incr nsub;
+      ) t.t_blocks_of_chunk.(j);
+      lprintf_nl "   = %d/%d" !nsub (List.length t.t_blocks_of_chunk.(j))
+    end;
+    t.t_converted_verified_bitmap.[j] <- '1'
+  end
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         verify (internal)                             *)
-(*                                                                       *)
-(*************************************************************************)
+(* aka set_completed_chunk (internal) *)
+let set_frontend_bitmap_2 t j =
+  match t.t_converted_verified_bitmap.[j] with
+  | '0' | '1' ->
+      if !verbose_swarming || !verbose then
+	lprintf_nl "Completed block %d/%d of %s"
+          (j + 1) t.t_nchunks (file_best_name t.t_file);
+      let s = t.t_s in
+      List.iter (fun i -> set_completed_block None s i)
+	t.t_blocks_of_chunk.(j)
+  | '2' | '3' -> ()
+  | _ -> assert false
+
+(* aka set_verified_chunk (internal) *)
+let set_frontend_bitmap_3 t j =
+  let mark_verified () =
+    t.t_converted_verified_bitmap.[j] <- '3';
+    if !verbose_swarming || !verbose then
+      lprintf_nl "Verified block %d/%d of %s"
+        (j + 1) t.t_nchunks (file_best_name t.t_file);
+    if t.t_primary then begin
+      let s = t.t_s in
+      (* The primary is supposed to propagate verified chunks to the file *)
+      List.iter (fun i -> set_verified_block s i) t.t_blocks_of_chunk.(j);
+      if !verbose_swarming then
+	print_s "VERIFIED" s
+    end;
+    t.t_verified t.t_nverified_chunks j in
+  match t.t_converted_verified_bitmap.[j] with
+  | '0' | '1' ->
+      t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1;
+      t.t_nverified_chunks <- t.t_nverified_chunks + 1;
+      mark_verified ();
+  | '2' ->
+      t.t_nverified_chunks <- t.t_nverified_chunks + 1;
+      mark_verified ();
+  | '3' -> ()
+  | _ -> assert false
+
+let set_chunks_verified_bitmap t bitmap =
+  string_iter (fun j c ->
+    match c with
+    | '0' | '1' -> 
+	()
+    | '2' ->
+	set_frontend_bitmap_2 t j
+    | '3' ->
+	set_frontend_bitmap_3 t j;
+        if t.t_converted_verified_bitmap.[j] <> '3' then
+          lprintf_nl "FIELD AS BEEN CLEARED"
+    | _ -> assert false
+  ) bitmap
 
-let verify t chunks num begin_pos end_pos =
-  file_verify t.t_file chunks.(num) begin_pos end_pos
+let chunks_verified_bitmap t = t.t_converted_verified_bitmap
+
+(** Check the equality of the hash of [t]'s data between offsets
+    [begin_pos] and [end_pos] against the value of [uid] *)
 
 (*************************************************************************)
 (*                                                                       *)
